;
;                       ķ
;                                                     
;                                MASM 6.x macros      
;                                                     
;                       Ķ
;			   Jim Brooks (c) July 1993   
;                       Ľ
;
;------------------------------------------------------------------------------
;Define the equate _PM to include PM-related macros.
;------------------------------------------------------------------------------

option		dotname

@8		textequ <byte ptr>
@16             textequ <word ptr>
@32             textequ <dword ptr>
@48             textequ <fword ptr>
offset16        textequ <lowword offset>        ;force 32-bit offset to be a 16-bit offset

;--------------------------------

zero		macro	oper

		xor	oper, oper
endm

@DOSExit MACRO return
    IFB     <return>
        mov     ah, 4Ch
    ELSE
        mov     ax, 4C00h + (return AND 0FFh)
    ENDIF
    int     21h
ENDM

;

IFDEF _PM

;CR0 bits:
pe		equ 1				;CR0's protect mode enable bit
ts		equ 1 shl 3			;CR0's task-switch flag
am		equ 1 shl 18			;CR0's alignment mask bit
pg		equ 1 shl 31			;CR0's page mode enable bit
vme		equ 1 shl 0			;CR4's VME
pvi		equ 1 shl 1			;CR4's PVI

;EFLAGS bits:
cfl		equ 1				;carry flag in EFLAGS
pfl		equ 1 shl 2			;parity flag in EFLAGS
afl		equ 1 shl 4			;auxillary flag in EFLAGS
zfl		equ 1 shl 6			;zero flag in EFLAGS
sfl		equ 1 shl 7			;sign flag in EFLAGS
tfl		equ 1 shl 8			;trap flag in EFLAGS
ifl		equ 1 shl 9			;interrupt flag in EFLAGS
dfl		equ 1 shl 10			;direction flag in EFLAGS
ofl		equ 1 shl 11			;overflow flag in EFLAGS
ntfl		equ 1 shl 14			;nested-task flag in EFLAGS
rfl		equ 1 shl 16			;resume flag in EFLAGS
vmfl		equ 1 shl 17			;virtual 8086 flag in 32-bit EFLAGS
acfl		equ 1 shl 18			;alignment check bit in EFLAGS
IOPL0		equ 0 shl 12			;EFLAGS privilege level=0 (I/O restricted)
IOPL1		equ 1 shl 12			;EFLAGS privilege level=1 (I/O restricted)
IOPL2		equ 2 shl 12			;EFLAGS privilege level=2 (I/O restricted)
IOPL3		equ 3 shl 12			;EFLAGS privilege level=3 (any level can do I/O)
vif		equ 1 shl 19			;VIF in EFLAGS
vip		equ 1 shl 20			;VIP in EFLAGS

;Ensures specified PL by using Boolean logic

$PL0            equ <and not 01100000b>
$PL1            equ <and not 01000000b or 00100000b>
$PL2            equ <and not 00100000b or 01000000b>
$PL3            equ <or 01100000b>

$RPL0           equ <and not 11b>
$RPL1           equ <and not 10b or 01b>
$RPL2           equ <and not 01b or 10b>
$RPL3           equ <or 11b>

$LDT            equ <or 100b>
$GDT            equ <and not 100b>

@CS             equ  2Eh
@DS             equ  3Eh
@ES             equ  26h
@SS             equ  36h
@FS             equ  64h
@GS             equ  65h
@REPNZ		equ 0F2h
@REPZ		equ 0F3h
@REP            equ 0F3h
@OperandOverride equ  66h
@AddressOverride equ  67h

;----------------------
tss_backlink	    = 0  *4			;back link (selector,0)
tss_esp0	    = 1  *4			;ESP   CPL0
tss_ss0 	    = 2  *4			;SS    CPL0
tss_esp1	    = 3  *4			;ESP   CPL1
tss_ss1 	    = 4  *4			;SS    CPL1
tss_esp2	    = 5  *4			;ESP   CPL2
tss_ss2 	    = 6  *4			;SS    CPL2
tss_cr3 	    = 7  *4			;CR3 \
tss_eip 	    = 8  *4			;EIP  \
tss_eflags	    = 9  *4			;EFL   \
tss_eax 	    = 10 *4			;EAX	\
tss_ecx 	    = 11 *4			;ECX	 \
tss_edx 	    = 12 *4			;EDX	  \
tss_ebx 	    = 13 *4			;EBX	   \
tss_esp 	    = 14 *4			;ESP	    \
tss_ebp 	    = 15 *4			;EBP	     > Updated when task is left
tss_esi 	    = 16 *4			;ESI	    /  Re-loaded when task starts
tss_edi 	    = 17 *4			;EDI	   /
tss_es		    = 18 *4			;ES	  /
tss_cs		    = 19 *4			;CS	 /
tss_ss		    = 20 *4			;SS	/
tss_ds		    = 21 *4			;DS    /
tss_fs		    = 22 *4			;FS   /
tss_gs		    = 23 *4			;GS  /
tss_ldt 	    = 24 *4			;Task's LDT selector
tss_debug	    = 25 *4			;debug trap bit (16-bits)
tss_iobitmapbase    = 25 *4 +2			;I/O map base	(16-bits)
tss_PDBR	    equ tss_cr3
tss_iobitmapbase_t  equ tss_debug		;		(32-bits)
;----------------------

ENDIF
